<?php

namespace Ulmus\User\Lib;

use Psr\Http\Message\ServerRequestInterface;

enum HeaderAuthenticationTypeEnum : string
{
    case Basic = "basic";
    case Digest = "digest";
    case Bearer = "bearer";
    case Token = "token";

    public static function fromRequest(ServerRequestInterface $request) : ? static
    {
        if ($request->hasHeader('authorization')) {
            list($method, ) = explode(' ', $request->getHeaderLine('authorization'), 2);

            return static::tryFrom(strtolower($method));
        }

        return null;
    }
}