<?php

namespace Ulmus\User\Middleware;

use Psr\Http\{
    Message\ResponseInterface,
    Message\ServerRequestInterface,
    Server\MiddlewareInterface,
    Server\RequestHandlerInterface
};
use Ulmus\User\Entity\UserInterface;
use Ulmus\User\Authorize\HeaderAuthentication;
use Ulmus\User\Lib\Authenticate;

class HeaderAuthenticationMiddleware implements MiddlewareInterface
{
    public function __construct(
        protected HeaderAuthentication $authenticator,
    ) { }

    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler): ResponseInterface
    {
        if ( $this->authenticator->catchRequest($request) ) {
            $request = $this->authenticator->connect($request);
        }

        return $handler->handle($request);
    }
}
